#include "Main.h"
#include <sys/types.h>
#include <newdel.h>
#include <libps.h>
#include <string.h>
#include <stdio.h>


char pNames[MAX_NAME_LENGTH][MAX_NAMES] ;

int nHandle ;

#define OT_LENGTH	1		/*  Ordering table number*/

//  Ordering table related variables
GsOT		WorldOT[2];
GsOT_TAG	OTTags[2][1<<OT_LENGTH];

volatile  u_char	*bb0 , 
									*bb1 ;


int nEntries ;

const u_long PADLup     = ( 1<<12);
const u_long PADLdown   = ( 1<<14);
const u_long PADLleft   = ( 1<<15);
const u_long PADLright  = ( 1<<13);
const u_long PADRup     = ( 1<< 4);
const u_long PADRdown   = ( 1<< 6);
const u_long PADRleft   = ( 1<< 7);
const u_long PADRright  = ( 1<< 5);
const u_long PADi       = ( 1<< 9);
const u_long PADj       = ( 1<<10);
const u_long PADk       = ( 1<< 8);
const u_long PADl       = ( 1<< 3);
const u_long PADm       = ( 1<< 1);
const u_long PADn       = ( 1<< 2);
const u_long PADo       = ( 1<< 0);
const u_long PADh       = ( 1<<11);
const u_long PADL1      =PADn ;
const u_long PADL2      =PADo ;
const u_long PADR1      =PADl	;
const u_long PADR2      =PADm	;
const u_long PADstart   =PADh	;
const u_long PADselect  =PADk	;


const u_long PADtriangle = PADRup		;
const u_long PADcross    = PADRdown	;
const u_long PADsquare   = PADRleft	;
const u_long PADcircle   = PADRright;



const u_long kPrevSound = PADsquare ;
const u_long kNextSound = PADcircle ;
const u_long kPlay			= PADcross ;

char* pText[] =
{
	"Sound Player by Steve Dunn\n",
	"Press \"Start\" to Quit...\n",
	"\n" ,
	"Circle=Next Sound\n",
	"Square=Prev Sound\n",
	"Cross =Play Sound\n",
	NULL
};


main()
{
	bool bOK = parseText( ) ;
	SetVideoMode(MODE_PAL);
	ResetGraph(0);

	GsInitGraph(320, 240, 4, 0, 0);
	GsDefDispBuff(0,0,0,240);
	
	/* Load basic font pattern in frame buffer */
	FntLoad(960, 256);	

	/* Font display location setting */
	FntOpen(16, 16, 256, 200, 0, 512);	

	 // Set the Actual Size of the Video memory
	 GsInitGraph(SCREEN_WIDTH, SCREEN_HEIGHT, GsINTER|GsOFSGPU, 1, 0);
	 
	 // Set the Top Left Coordinates Of The Two Buffers in video memory
	 GsDefDispBuff(0, 0, 0, SCREEN_HEIGHT);

	
	initPad( ) ;
	int nId = 0 ;
	
	/* Ordering table information setting */
	for (int i = 0; i < 2; i++) 
	{
		WorldOT[i].length = OT_LENGTH;
		WorldOT[i].org = OTTags[i];
	}



	initSounds( ) ;	

	SsSetMVol( 127,127 ) ;

	while( 1 )
	{
		int activeBuff = GsGetActiveBuff();

		/* Ordering table clear */
		GsClearOt(0, 0, &WorldOT[activeBuff]);

		DrawSync(0);		/* Waiting for end of drawing */
		int cnt = VSync(0);	/* Waiting for vertical synchronisation 						interrupt */
		GsSwapDispBuff();	/* Double buffer switching */

		/* Registration to screen clear primitive ordering table */
		GsSortClear(60, 120, 120, &WorldOT[activeBuff]);

		/* Drawing of primitive registered in OT */
		GsDrawOt(&WorldOT[activeBuff]);

		int i = -1 ;
		while( pText[++i] )
			FntPrint( "%s", pText[i] ) ;
	
		u_long currentKey = getPad( ) ;
		if ( currentKey & PADstart )
			break ;
		
		if ( currentKey & kNextSound )
		{
			while ( getPad( )  == kNextSound ) ;
			if ( nId < nEntries -1 )
				++nId ;
		}
		
		if ( currentKey & kPrevSound )
		{
			while ( getPad( )  == kPrevSound ) ;
			if ( nId )
				--nId ;
		}
		
		if ( ::nHandle )
		{
			if ( currentKey & kPlay )
			{
				FntPrint("Playing %d\n", nId ) ;
				while( getPad( )  == kPlay ) ;
				play(nId ) ;//sf.play(nId ) ;
			}
		}
		else
			FntPrint(	"\n***THE SOUNDS COULD NOT\n"
								"BE INITIALISED !...\n\n" ) ;


		FntPrint("\n\n%s(%d)\n", pNames[nId], nId+1 ) ;
		FntFlush(-1);
	}
}


bool
parseText( )
{
	bool bRet = false ;
	u_char* p = (u_char*)TEXT_ADDR ;
	int nIndex = 0 ;
	int nameIndex = 0 ;
	u_char* pDest = (u_char*)pNames[nIndex] ;
	while( nIndex <= MAX_NAMES )
	{
		u_char theChar = *p++ ;
		if ( theChar && theChar != '\r' )		//ignore CRs
		{
		
			if ( theChar == '\n' )
				theChar = '\0' ;

			*(pDest+nameIndex++) = theChar ;
			if ( ! theChar )		//end of line
			{
				nameIndex = 0 ;
				if ( ! strcmp( (char*)pNames[nIndex], (char*)"end" )  )
					break ;		// the end of the list
				++nIndex ;			//start setting the next name
				pDest = (u_char*)pNames[nIndex] ;
			}
		}
//		else
//			return false ;
	}
	
	nEntries = nIndex ;
	return true ;
			
	
}



Voice
play( int  nProgram )
{
	return (Voice)SsUtKeyOn( ::nHandle, nProgram, 0, 48, 0, 127, 127);
}


void
initSounds( )
{
	::nHandle = SsVabTransfer((u_char*)VH_ADDR, (u_char*)VB_ADDR, -1, 1);
}

void
stopSounds( )
{
	printf("Closing VAB with handle of %d\n", ::nHandle ) ;
	SsVabClose( ::nHandle ) ;
}


void
initPad( )
{
	GetPadBuf(&::bb0, &::bb1);
}

u_long
getPad( )
{
	return(
				~ ( *(::bb0+3) | *(::bb0+2) << 8 | *(::bb1+3) << 16 | *(::bb1+2) << 24)
				);
}